package com.gxzc.zen

import com.baomidou.mybatisplus.generator.AutoGenerator
import com.baomidou.mybatisplus.generator.config.*
import com.baomidou.mybatisplus.generator.config.converts.MySqlTypeConvert
import com.baomidou.mybatisplus.generator.config.rules.DbColumnType
import com.baomidou.mybatisplus.generator.config.rules.DbType
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy
import java.io.File

/**
 *
 * @author NorthLan
 * @date 2018/1/24
 * @url https://noahlan.me
 */
fun main(args: Array<String>) {
    val mpg = AutoGenerator()

    val path = File("zen-api").absolutePath

    // 全局配置
    val gc = GlobalConfig()
    with(gc) {
        outputDir = path + "/src/main/kotlin"
        isFileOverride = true
        isActiveRecord = false
        isEnableCache = false
        isOpen = true
        author = "NorthLan"
        isKotlin = true
        isBaseResultMap = true
        mapperName = "%sDao"
        xmlName = "%sDao"
        serviceName = "I%sService"
        serviceImplName = "%sServiceImpl"
    }
    mpg.globalConfig = gc

    // 数据源
    val dataSource = DataSourceConfig()
    with(dataSource) {
        dbType = DbType.MYSQL
//        typeConvert = object :MySqlTypeConvert(){
//            override fun processTypeConvert(fieldType: String?): DbColumnType {
//                if(fieldType == "tinyint"){
//                    return DbColumnType.BOOLEAN
//                }
//                return super.processTypeConvert(fieldType)
//            }
//        }
        driverName = "com.mysql.jdbc.Driver"
        username = "root"
        password = "root"
        url = "jdbc:mysql://127.0.0.1:3306/archives_rec?characterEncoding=utf8"
    }
    mpg.dataSource = dataSource

    // 策略配置
    val strategy = StrategyConfig()
    with(strategy) {
        setDbColumnUnderline(true)
        isCapitalMode = false
        naming = NamingStrategy.underline_to_camel
        //            setTablePrefix()
        superEntityClass = "com.gxzc.zen.common.base.BaseModel"
        setSuperEntityColumns("id", "create_by", "create_time", "update_by", "update_time", "remark", "enable")
        superMapperClass = "com.gxzc.zen.common.base.BaseMapper"
        superServiceClass = "com.gxzc.zen.common.base.BaseService"
        superServiceImplClass = "com.baomidou.mybatisplus.service.impl.ServiceImpl"
//            superControllerClass = ""
//        setInclude("user")
        isEntityBooleanColumnRemoveIsPrefix = true
        logicDeleteFieldName = "enable"
//            setExclude("")
    }
    mpg.strategy = strategy

    // 包配置
    val pc = PackageConfig()
    with(pc) {
        parent = "com.gxzc.zen.api.rec"
//        moduleName = "zen-orm"
        entity = "model"
    }
    mpg.packageInfo = pc

    mpg.execute()
}
