package com.gxzc.zen.orm

import com.alibaba.druid.support.http.StatViewServlet
import com.alibaba.druid.support.http.WebStatFilter
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty
import org.springframework.boot.context.properties.ConfigurationProperties
import org.springframework.boot.web.servlet.FilterRegistrationBean
import org.springframework.boot.web.servlet.ServletRegistrationBean
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration

/**
 *
 * @author NorthLan at 2018/1/26
 */
@Configuration
@ConfigurationProperties(prefix = "druid.view")
@ConditionalOnProperty(prefix = "druid.view", name = ["enable"], havingValue = "true", matchIfMissing = true)
class DruidViewConfig {
    var username: String? = null
    var password: String? = null
    var slowSql: String? = null

    @Bean
//    @ConditionalOnProperty(prefix = "druid.view", name = ["enable"], havingValue = "true", matchIfMissing = true)
    fun druidServlet(): ServletRegistrationBean {
        return ServletRegistrationBean().also {
            it.setServlet(StatViewServlet())
            it.addUrlMappings("/druid/*")
            it.addInitParameter("loginUsername", username)
            it.addInitParameter("loginPassword", password)
            it.addInitParameter("logSlowSql", slowSql)
        }
    }

    @Bean
//    @ConditionalOnProperty(prefix = "druid.view", name = ["enable"], havingValue = "true", matchIfMissing = true)
    fun filterRegistrationBean(): FilterRegistrationBean {
        return FilterRegistrationBean().also {
            it.filter = WebStatFilter()
            it.addUrlPatterns("/*")
            it.addInitParameter("exclusions", "*.js,*.gif,*.jpg,*.png,*.css,*.ico,/druid/*")
            it.addInitParameter("profileEnable", "true")
        }
    }
}