package com.gxzc.zen.orm.base

import org.springframework.boot.autoconfigure.jdbc.DataSourceProperties

/**
 * 数据源配置基类
 * @author NorthLan at 2018/1/27
 */
open class BaseDataSourceProperties : DataSourceProperties() {
    var prefix: String = "datasource"
    var mapperLocation: String = ""
    var initialSize: Int = 5
    var minIdle: Int = 5
    var maxActive: Int = 20
    var maxWait: Long = 60000

    var timeBetweenEvictionRunsMillis: Long = 60000
    var minEvictableIdleTimeMillis: Long = 30000
    var validationQuery: String? = null
    var testWhileIdle: Boolean = true
    var testOnBorrow: Boolean = false
    var testOnReturn: Boolean = false
}